<?php
	// ======================================== \
	// Package: Mihalism Multi Host
	// Version: 4.0.0
	// Copyright (c) 2007, 2008 Mihalism, Inc.
	// License: http://www.gnu.org/licenses/gpl.txt GNU Public License
	// ======================================== /

	require_once "./source/includes/data.php";
	
	$mmhclass->templ->page_title = "{$mmhclass->info->config['site_name']} &raquo; Users &raquo; ";

	switch ($mmhclass->input->get_vars['act']) {
		case "register":
			$mmhclass->templ->templ_vars[] = array(
				"SITE_NAME"    => $mmhclass->info->config['site_name'],
				"LIGHTBOX_ID"  => $mmhclass->input->get_vars['lb_div'],
				"RETURN_URL"   => $mmhclass->input->get_vars['return'],
			);
			
			exit($mmhclass->templ->parse_template("users", "registration_lightbox"));
			break;
		case "register-d":
			$mmhclass->templ->page_title .= "Registration";
			
			if ($mmhclass->funcs->is_null($mmhclass->input->post_vars['username'])  == true || $mmhclass->funcs->is_null($mmhclass->input->post_vars['password']) == true || $mmhclass->funcs->is_null($mmhclass->input->post_vars['password-c']) == true || $mmhclass->funcs->is_null($mmhclass->input->post_vars['email_address']) == true || $mmhclass->funcs->is_null($mmhclass->input->post_vars['iagree']) == true) {
				$mmhclass->templ->error("Please ensure that all required fields of the form on the previous page had been filled in correctly.", true);
			} elseif ($mmhclass->funcs->valid_email($mmhclass->input->post_vars['email_address']) == false) {
				$mmhclass->templ->error("The email address entered appears to be invalid.", true);
			} elseif ($mmhclass->input->post_vars['password'] != $mmhclass->input->post_vars['password-c']) {
				$mmhclass->templ->error("Please ensure that the passwords that have been entered exactly match each other. ", true);
			} elseif (strlen($mmhclass->input->post_vars['password']) < 6 || strlen($mmhclass->input->post_vars['password']) > 30) {
				$mmhclass->templ->error("Please ensure you have entered a valid password.", true);
			} elseif ($mmhclass->funcs->valid_string($mmhclass->input->post_vars['username']) == false || strlen($mmhclass->input->post_vars['username']) < 3 || strlen($mmhclass->input->post_vars['username']) > 30) {
				$mmhclass->templ->error("Please ensure you have entered a valid username.", true);
			} elseif ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_user_info` WHERE `username` = '{$mmhclass->input->post_vars['username']}';")) == 1) {
				$mmhclass->templ->error("Sorry but the requested username is already in use.", true);
			} elseif ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_user_info` WHERE `email_address` = '{$mmhclass->input->post_vars['email_address']}';")) == 1) {
				$mmhclass->templ->error("Sorry but the entered email address is already in use.", true);
			} else {
				$mmhclass->db->query("INSERT INTO `mmh_user_info` (`username`, `password`, `email_address`, `ip_address`, `private_gallery`, `time_joined`, `user_group`) VALUES ('{$mmhclass->input->post_vars['username']}', '".md5($mmhclass->input->post_vars['password'])."', '{$mmhclass->input->post_vars['email_address']}', '{$mmhclass->input->server_vars['remote_addr']}', 0, ".time().", 'normal_user');");

				$mmhclass->templ->message("<b>{$mmhclass->input->post_vars['username']}</b>, You have been successfully registered. <br /><br /> <a href=\"index.php?rurl={$mmhclass->input->post_vars['return']}\">Return To Previous Page</a> <br /> <a href=\"index.php\">Site Index</a>", true);		
			}
			break;
		case "login":
			$mmhclass->templ->templ_vars[] = array(
				"LIGHTBOX_ID" => $mmhclass->input->get_vars['lb_div'],
				"RETURN_URL"  => $mmhclass->input->get_vars['return'],
			);
			
			exit($mmhclass->templ->parse_template("users", "login_lightbox"));
			break;
		case "login-d":
			$mmhclass->templ->page_title .= "Log In";
			
			if ($mmhclass->funcs->is_null($mmhclass->input->post_vars['username']) == true || $mmhclass->funcs->is_null($mmhclass->input->post_vars['password'] == true)) {
				$mmhclass->templ->error("Please ensure that all required fields of the form on the previous page had been filled in correctly.", true);
			} elseif ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_user_info` WHERE `username` = '{$mmhclass->input->post_vars['username']}' AND `password` = '".md5($mmhclass->input->post_vars['password'])."';")) != 1) {
				$mmhclass->templ->error("Invalid username and or password.", true);
			} else {
				$session_id = md5($mmhclass->funcs->random_string(30));
				$mmhclass->info->user_data = $mmhclass->db->fetch_array($mmhclass->db->query("SELECT * FROM `mmh_user_info` WHERE `username` = '{$mmhclass->input->post_vars['username']}' AND `password` = '".md5($mmhclass->input->post_vars['password'])."';"));
				$mmhclass->db->query("UPDATE `mmh_user_info` SET `ip_address` = '{$mmhclass->input->server_vars['remote_addr']}' WHERE `user_id` = '{$mmhclass->info->user_data['user_id']}';");
				$mmhclass->db->query("INSERT INTO `mmh_user_sessions` (session_id, session_start, user_id, user_agent, ip_address) VALUES ('{$session_id}', '".time()."', '{$mmhclass->info->user_data['user_id']}', '{$mmhclass->input->server_vars['http_user_agent']}', '{$mmhclass->input->server_vars['remote_addr']}');");

				setcookie("mmh_user_session", "session_delete", (time() - 60000));	

				if (setcookie("mmh_user_session", serialize(array("session_id" => $session_id, "user_id" => $mmhclass->info->user_data['user_id'])), (time() + 31536000), $mmhclass->info->script_path) == true) {
					$mmhclass->info->is_user = true;
					$mmhclass->templ->message("You have been successfully logged in. <br /><br /> <a href=\"index.php?rurl={$mmhclass->input->post_vars['return']}\">Return To Previous Page</a> <br /><br /> <a href=\"users.php?act=gallery\">My Gallery</a> <br /> <a href=\"index.php\">Site Index</a>", true);
				} else {
					$mmhclass->templ->error("Log in failed. <br /><br /> Failed to set cookie <b>mmh_user_session</b>.", true);
				}
			}
			break;
		case "logout":
			$mmhclass->templ->page_title .= "Log Out";
			
			if (setcookie("mmh_user_session", "session_delete", (time() - 60000)) == true) {
				$mmhclass->info->is_user = false;
				$mmhclass->templ->message("You have been successfully logged out. <br /><br /> <a href=\"index.php\">Site Index</a>", true);
			} else {
				$mmhclass->templ->error("Log out failed. <br /><br /> Failed to unset cookie <b>mmh_user_session</b>.", true);
			}
			break;
		case "lost_password":
			$mmhclass->templ->templ_vars[] = array(
				"LIGHTBOX_ID" => $mmhclass->input->get_vars['lb_div'],
			);
			
			exit($mmhclass->templ->parse_template("users", "forgotten_password_lightbox"));
			break;
		case "lost_password-d":
			$mmhclass->templ->page_title .= "Lost Password";
			
			if ($mmhclass->funcs->is_null($mmhclass->input->post_vars['username']) == true || $mmhclass->funcs->is_null($mmhclass->input->post_vars['email_address']) == true) {
				$mmhclass->templ->error("Please ensure that all required fields of the form on the previous page had been filled in correctly.", true);
			} elseif ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_user_info` WHERE `username` = '{$mmhclass->input->post_vars['username']}' AND `email_address` = '{$mmhclass->input->post_vars['email_address']}';")) != 1) {
				$mmhclass->templ->error("Invalid username and or email address.", true);
			} else {
				$auth_key     = md5($mmhclass->funcs->random_string(30));
				$new_password = $mmhclass->funcs->random_string(10);
				$user_data    = $mmhclass->db->fetch_array($mmhclass->db->query("SELECT * FROM `mmh_user_info` WHERE `username` = '{$mmhclass->input->post_vars['username']}' AND `email_address` = '{$mmhclass->input->post_vars['email_address']}';"));

				$mmhclass->db->query("INSERT INTO `mmh_user_forgotten_passwords` (auth_key, new_password, user_id, time_requested, ip_address) VALUES ('{$auth_key}', '".md5($new_password)."', '{$user_data['user_id']}', '".time()."', '{$mmhclass->input->server_vars['remote_addr']}');");

				$mmhclass->templ->templ_vars[] = array(
					"USERNAME"     => $user_data['username'],
					"BASE_URL"     => $mmhclass->info->base_url,
					"AUTH_KEY"    => $auth_key,
					"NEW_PASSWORD" => $new_password,
				);

				$message_body = strip_tags(str_replace("<br />", "\n", $mmhclass->templ->parse_template("users", "forgotten_password_email")));

				if (mail($user_data['email_address'], "New password activation at {$mmhclass->info->config['site_name']}", $message_body, "From: {$mmhclass->info->config['site_name']} <{$mmhclass->info->config['email_out']}>")) {
					$mmhclass->templ->message("An activation email has been sent to the entered account. No change to the current password will happen until the link in the email is clicked. <br /><br /> <a href=\"index.php\">Site Index</a>", true);
				} else {
					$mmhclass->templ->error("Failed to send email due to an unknown problem.");
				}
			}
			break;
		case "lost_password-a":
			$mmhclass->templ->page_title .= "Lost Password Activation";
			
			if ($mmhclass->funcs->is_null($mmhclass->input->get_vars['id']) == true || $mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_user_forgotten_passwords` WHERE `auth_key` = '{$mmhclass->input->get_vars['id']}';")) != 1) {
				$mmhclass->templ->error("The entered authentication key does not exist or has already been used.", true);
			} else {
				$new_password_data = $mmhclass->db->fetch_array($mmhclass->db->query("SELECT * FROM `mmh_user_forgotten_passwords` WHERE `auth_key` = '{$mmhclass->input->get_vars['id']}';"));

				$mmhclass->db->query("DELETE FROM `mmh_user_forgotten_passwords` WHERE `auth_key` = '{$mmhclass->input->get_vars['id']}';");
				$mmhclass->db->query("UPDATE `mmh_user_info` SET `password` = '{$new_password_data['new_password']}' WHERE `user_id` = '{$new_password_data['user_id']}';");
			
				$mmhclass->templ->message("Password has been successfully updated. <br /><br /> <a href=\"index.php\">Site Index</a>", true);
			}
			break;
		case "user_list":
			$mmhclass->templ->page_title .= "User Galleries";

			$sql = $mmhclass->db->query("SELECT * FROM `mmh_user_info` ORDER BY `user_id` DESC LIMIT <# QUERY_LIMIT #>;");
			while ($row = $mmhclass->db->fetch_array($sql)) {
				$mmhclass->templ->templ_globals['get_whileloop'] = true;
				
				$mmhclass->templ->templ_vars[] = array(
					"USERNAME"        => $row['username'],
					"USER_ID"         => $row['user_id'],
					"TDCLASS"         => $tdclass = (($tdclass == "tdrow1") ? "tdrow2" : "tdrow1"),
					"TIME_JOINED"     => date($mmhclass->info->config['date_format'], $row['time_joined']),
					"GALLERY_STATUS"  => (($row['private_gallery'] == 1) ? "Private" : "Public"),
					"TOTAL_UPLOADS"   => $mmhclass->funcs->format_number($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$row['user_id']}';"))),
				);

				$mmhclass->templ->templ_globals['user_list_whileloop'] .= $mmhclass->templ->parse_template("users", "user_list_page");

				unset($mmhclass->templ->templ_globals['get_whileloop'], $mmhclass->templ->templ_vars);	
			}

			$mmhclass->templ->templ_vars[] = array(
				"PAGINATION_LINKS" => $mmhclass->templ->pagelinks("users.php?act=user_list", $mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_user_info`;"))),
			);

			$mmhclass->templ->output("users", "user_list_page");
			break;
		case "gallery":
			$mmhclass->templ->page_title .= "User Gallery";
			
			$mmhclass->input->get_vars['gal']   = round($mmhclass->input->get_vars['gal']);
			$mmhclass->input->get_vars['cat']   = round($mmhclass->input->get_vars['cat']);
			$mmhclass->info->gallery_owner_data = (($mmhclass->funcs->is_null($mmhclass->input->get_vars['gal']) == false) ? $mmhclass->db->fetch_array($mmhclass->db->query("SELECT * FROM `mmh_user_info` WHERE `user_id` = '{$mmhclass->input->get_vars['gal']}';")) : $mmhclass->info->user_data);
			$mmhclass->info->gallery_url        = ("{$mmhclass->info->base_url}users.php?act=gallery".(($mmhclass->funcs->is_null($mmhclass->input->get_vars['gal']) == true) ? NULL : "&amp;gal={$mmhclass->info->gallery_owner_data['user_id']}"));

			if ($mmhclass->funcs->is_null($mmhclass->input->get_vars['gal']) == true && $mmhclass->info->is_user == false) {
				$mmhclass->templ->error("You must log in first in order to view your gallery.", true);
			} elseif ($mmhclass->funcs->is_null($mmhclass->input->get_vars['gal']) == false && $mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_user_info` WHERE `user_id` = '{$mmhclass->input->get_vars['gal']}';")) != 1) {
				$mmhclass->templ->error("The requested gallery does not exist.", true);
			} elseif ($mmhclass->info->is_admin == false && $mmhclass->funcs->is_null($mmhclass->input->get_vars['gal']) == false && $mmhclass->info->gallery_owner_data['private_gallery'] == 1) {
				$mmhclass->templ->message("The requested gallery is set to private.", true);
			} else {
				if ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$mmhclass->info->gallery_owner_data['user_id']}' AND `album_id` = '{$mmhclass->input->get_vars['cat']}' ORDER BY `file_id` DESC LIMIT <# QUERY_LIMIT #>;")) < 1) {
					$mmhclass->templ->templ_globals['empty_gallery'] = true;
				} else {
					$sql = $mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$mmhclass->info->gallery_owner_data['user_id']}' AND `album_id` = '{$mmhclass->input->get_vars['cat']}' ORDER BY `file_id` DESC LIMIT <# QUERY_LIMIT #>;");
					while ($row = $mmhclass->db->fetch_array($sql)) {
						if ($tdcount >= 4) {
							$break_line = true;
							$tdcount = 0;
						}
						$tdcount++;
					
						if ($mmhclass->funcs->is_null($mmhclass->input->get_vars['gal']) == true) {
							$mmhclass->templ->templ_globals['file_options'] = true;
						}
					
						$mmhclass->templ->templ_vars[] = array(
							"FILENAME"     => $row['filename'],
							"FILE_TITLE"   => (($mmhclass->funcs->is_null($mmhclass->input->get_vars['gal']) == true) ? "<span class=\"arial\" title=\"Click to rename\" id=\"{$row['filename']}\" onclick=\"javascript:gallery_action('rename', this.id);\">{$row['file_title']}</span>" : "<a href=\"viewer.php?file={$row['filename']}\">{$row['file_title']}</a>"),
							"TDCLASS"      => $tdclass = (($tdclass == "tdrow1") ? "tdrow2" : "tdrow1"),
							"TABLE_BREAK"  => (($break_line == true) ? "</tr><tr>" : NULL),
						);
					
						$gallery_html .= $mmhclass->templ->parse_template("global", "global_gallery_layout");

						unset($break_line, $mmhclass->templ->templ_globals['get_whileloop'], $mmhclass->templ->templ_vars);	
					}
				}
							
				$sql = $mmhclass->db->query("SELECT * FROM `mmh_gallery_albums` WHERE `gallery_id` = '{$mmhclass->info->gallery_owner_data['user_id']}';");
				while ($row = $mmhclass->db->fetch_array($sql)) {
					$mmhclass->templ->templ_globals['get_whileloop'] = true;
				
					$mmhclass->templ->templ_vars[] = array(
						"ALBUM_ID"      => $row['album_id'],
						"ALBUM_NAME"    => $row['album_title'],
						"TOTAL_UPLOADS" => $mmhclass->funcs->format_number($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$mmhclass->info->gallery_owner_data['user_id']}' AND `album_id` = '{$row['album_id']}';"))),
						"PAGE_URL"      => $mmhclass->info->gallery_url,
						"RETURN_URL"         => base64_encode($mmhclass->info->page_url),
					);
					
					$mmhclass->templ->templ_globals['album_pulldown_link_whileloop'] .= $mmhclass->templ->parse_template("users", "my_gallery_page");

					unset($mmhclass->templ->templ_vars, $mmhclass->templ->templ_globals['get_whileloop']);
				}
		
				$mmhclass->templ->templ_vars[] = array(
					"GALLERY_OWNER"      => $mmhclass->info->gallery_owner_data['username'],
					"PAGINATION_LINKS"   => $mmhclass->templ->pagelinks(($mmhclass->info->gallery_url.(($mmhclass->funcs->is_null($mmhclass->input->get_vars['cat']) == true) ? NULL : "&amp;cat={$mmhclass->input->get_vars['cat']}")), $mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$mmhclass->info->gallery_owner_data['user_id']}' AND `album_id` = '{$mmhclass->input->get_vars['cat']}';"))),			
					"GALLERY_HTML"       => $gallery_html,
					"GALLERY_ID"         => $mmhclass->info->gallery_owner_data['user_id'],
					"CURRENT_PAGE"       => $mmhclass->info->current_page,
					"PAGE_URL"           => $mmhclass->info->gallery_url,
					"RETURN_URL"         => base64_encode($mmhclass->info->page_url),
					"EMPTY_GALLERY"      => $mmhclass->templ->message("The requested gallery is empty.", false),
					"TOTAL_UPLOADS"      => $mmhclass->funcs->format_number($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$mmhclass->info->gallery_owner_data['user_id']}';"))),
					"TOTAL_ROOT_UPLOADS" => $mmhclass->funcs->format_number($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$mmhclass->info->gallery_owner_data['user_id']}' AND `album_id` = '0';"))),
				);
				
				$mmhclass->templ->output("users", "my_gallery_page");
			}
			break;
		case "rename_file_title":
			if ($mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} elseif ($mmhclass->funcs->is_null($mmhclass->input->get_vars['file']) == true) {
				$mmhclass->templ->error("Please select a file to continue.", true);
			} elseif (is_file($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].basename($mmhclass->input->get_vars['file'])) == false) {
				$mmhclass->templ->error("The requested file <b>{$mmhclass->input->get_vars['file']}</b> does not exist.", true);
			} elseif ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$mmhclass->info->user_data['user_id']}' AND `filename` = '{$mmhclass->input->get_vars['file']}';")) != 1) {
				$mmhclass->templ->error("You cannot rename the file <b>{$mmhclass->input->get_vars['file']}</b> because you do not own it.", true);
			} else {
				$filename  = basename($mmhclass->input->get_vars['file']);
				$new_title = strip_tags($mmhclass->input->get_vars['title']);
				
				$mmhclass->db->query("UPDATE `mmh_file_storage` SET `file_title` = '{$new_title}' WHERE `filename` = '{$filename}';");
	
				exit($new_title);
			}
			break;
		case "move_files":
			if ($mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} else {
				$files_to_move = preg_split("/,/", $mmhclass->input->get_vars['files']);
				for ($i = 0; $i < count($files_to_move); $i++) {
					$filename = basename($files_to_move[$i]);
					if ($mmhclass->funcs->is_null($filename) == true) {
						$mmhclass->templ->error("Please select a file to continue.", true);
					} elseif (is_file($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].basename($filename)) == false) {
						$mmhclass->templ->error("The requested file <b>{$filename}</b> does not exist.", true);
					} elseif ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$mmhclass->info->user_data['user_id']}' AND `filename` = '{$filename}';")) != 1) {
						$mmhclass->templ->error("You cannot move the file <b>{$filename}</b> because you do not own it.", true);
					}
				}
			
				$sql = $mmhclass->db->query("SELECT * FROM `mmh_gallery_albums` WHERE `gallery_id` = '{$mmhclass->info->user_data['user_id']}';");
				while ($row = $mmhclass->db->fetch_array($sql)) {
					$mmhclass->templ->templ_globals['get_whileloop'] = true;
					
					$mmhclass->templ->templ_vars[] = array(
						"ALBUM_ID"   => $row['album_id'],
						"ALBUM_NAME" => $row['album_title'],
					);
	
					$mmhclass->templ->templ_globals['album_options_whileloop'] .= $mmhclass->templ->parse_template("users", "move_files_lightbox");

					unset($mmhclass->templ->templ_vars, $mmhclass->templ->templ_globals['get_whileloop']);
				}
			
				$mmhclass->templ->templ_vars[] = array(
					"FILES_TO_MOVE" => $mmhclass->input->get_vars['files'],
					"LIGHTBOX_ID"   => $mmhclass->input->get_vars['lb_div'],
					"RETURN_URL"    => base64_encode(urldecode($mmhclass->input->get_vars['return'])),
				);
			
				exit($mmhclass->templ->parse_template("users", "move_files_lightbox"));
			}
			break;
		case "move_files-d":
			$mmhclass->templ->page_title .= "Move Files";
			
			if ($mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} else {
				$files_to_move = preg_split("/,/", $mmhclass->input->post_vars['files']);
				for ($i = 0; $i < count($files_to_move); $i++) {
					$filename = basename($files_to_move[$i]);
					if ($mmhclass->funcs->is_null($filename) == true) {
						$mmhclass->templ->error("Please select a file to continue.", true);
					} elseif (is_file($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].basename($filename)) == false) {
						$mmhclass->templ->error("The requested file <b>{$filename}</b> does not exist.", true);
					} elseif ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$mmhclass->info->user_data['user_id']}' AND `filename` = '{$filename}';")) != 1) {
						$mmhclass->templ->error("You cannot move the file <b>{$filename}</b> because you do not own it.", true);
					} else {
						$album_id = round($mmhclass->input->post_vars['move_to']);
						$filename = basename($filename);
						
						$mmhclass->db->query("UPDATE `mmh_file_storage` SET `album_id` = '{$album_id}' WHERE `filename` = '{$filename}';");
					}
				}
				
				$mmhclass->templ->message("Files have been successfully moved. <br /><br /> <a href=\"index.php?rurl={$mmhclass->input->post_vars['return']}\">Return To Previous Page</a> <br /> <a href=\"index.php\">Site Index</a>", true);
			}
			break;
		case "delete_files":
			if ($mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} else {
				$files_to_delete = preg_split("/,/", $mmhclass->input->get_vars['files']);
				for ($i = 0; $i < count($files_to_delete); $i++) {
					$filename = basename($files_to_delete[$i]);
					if ($mmhclass->funcs->is_null($filename) == true) {
						$mmhclass->templ->error("Please select a file to continue.", true);
					} elseif (is_file($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].basename($filename)) == false) {
						$mmhclass->templ->error("The requested file <b>{$filename}</b> does not exist.", true);
					} elseif ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$mmhclass->info->user_data['user_id']}' AND `filename` = '{$filename}';")) != 1) {
						$mmhclass->templ->error("You cannot delete the file <b>{$filename}</b> because you do not own it.", true);
					}
				}
			
				$mmhclass->templ->templ_vars[] = array(
					"FILES_TO_DELETE" => $mmhclass->input->get_vars['files'],
					"LIGHTBOX_ID"     => $mmhclass->input->get_vars['lb_div'],
					"RETURN_URL"      => base64_encode(urldecode($mmhclass->input->get_vars['return'])),
				);
			
				exit($mmhclass->templ->parse_template("users", "delete_files_lightbox"));
			}
			break;
		case "delete_files-d":
			$mmhclass->templ->page_title .= "Delete Files";
			
			if ($mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} else {
				$files_to_delete = preg_split("/,/", $mmhclass->input->post_vars['files']);
				for ($i = 0; $i < count($files_to_delete); $i++) {
					$filename = basename($files_to_delete[$i]);
					if ($mmhclass->funcs->is_null($filename) == true) {
						$mmhclass->templ->error("Please select a file to continue.", true);
					} elseif (is_file($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].basename($filename)) == false) {
						$mmhclass->templ->error("The requested file <b>{$filename}</b> does not exist.", true);
					} elseif ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_file_storage` WHERE `gallery_id` = '{$mmhclass->info->user_data['user_id']}' AND `filename` = '{$filename}';")) != 1) {
						$mmhclass->templ->error("You cannot delete the file <b>{$filename}</b> because you do not own it.", true);
					} else {
						$filename = basename($filename);
						
						if (unlink($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].$filename) == false) {
							$mmhclass->templ->error("Failed to delete file <b>{$filename}</b> because of an unknown problem.", true);
						}
						
						if (is_file($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].$mmhclass->funcs->thumbnail_name($filename)) == true) {
							if (unlink($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].$mmhclass->funcs->thumbnail_name($filename)) == false) {
								$mmhclass->templ->error("Failed to delete the thumbnail of the file <b>{$filename}</b> because of an unknown problem.", true);
							}
						}
						
						$mmhclass->db->query("DELETE FROM `mmh_file_storage` WHERE `filename` = '{$filename}';");
					}
				}
				
				$mmhclass->templ->message("Files have been successfully deleted. <br /><br /> <a href=\"index.php?rurl={$mmhclass->input->post_vars['return']}\">Return To Previous Page</a> <br /> <a href=\"index.php\">Site Index</a>", true);
			}
			break;
		case "albums-c":
			if ($mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} else {
				$mmhclass->templ->templ_vars[] = array(
					"LIGHTBOX_ID" => $mmhclass->input->get_vars['lb_div'],
					"RETURN_URL"  => $mmhclass->input->get_vars['return'],
				);
			
				exit($mmhclass->templ->parse_template("users", "new_album_lightbox"));
			}
			break;
		case "albums-c-d":
			$mmhclass->templ->page_title .= "New Album";
			
			if ($mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} elseif ($mmhclass->funcs->is_null($mmhclass->input->post_vars['album_title']) == true) {
				$mmhclass->templ->error("Please ensure that all required fields of the form on the previous page had been filled in correctly.", true);
			} else {
				$mmhclass->db->query("INSERT INTO `mmh_gallery_albums` (`album_title`, `gallery_id`) VALUES ('{$mmhclass->input->post_vars['album_title']}', '{$mmhclass->info->user_data['user_id']}');");
				
				$mmhclass->templ->message("Album has been successfully created. <br /><br /> <a href=\"index.php?rurl={$mmhclass->input->post_vars['return']}\">Return To Previous Page</a> <br /> <a href=\"index.php\">Site Index</a>", true);
			}
			break;
		case "albums-r":
			if ($mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} else {
				$album_id = round($mmhclass->input->get_vars['album']);
				
				if ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_gallery_albums` WHERE `album_id` = '{$album_id}' AND `gallery_id` = '{$mmhclass->info->user_data['user_id']}';")) != 1) {
					$mmhclass->templ->error("You cannot rename the requested album because you do not own it.", true);
				} else {
					$mmhclass->templ->templ_vars[] = array(
						"LIGHTBOX_ID" => $mmhclass->input->get_vars['lb_div'],
						"RETURN_URL"  => $mmhclass->input->get_vars['return'],
						"ALBUM_ID"    => $album_id,
					);
			
					exit($mmhclass->templ->parse_template("users", "rename_album_lightbox"));
				}
			}
			break;
		case "albums-r-d":
			$mmhclass->templ->page_title .= "Rename Album";
			
			if ($mmhclass->funcs->is_null($mmhclass->input->post_vars['album']) == true || $mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} elseif ($mmhclass->funcs->is_null($mmhclass->input->post_vars['album_title']) == true) {
				$mmhclass->templ->error("Please ensure that all required fields of the form on the previous page had been filled in correctly.", true);
			} else {
				$album_id = round($mmhclass->input->post_vars['album']);
				
				if ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_gallery_albums` WHERE `album_id` = '{$album_id}' AND `gallery_id` = '{$mmhclass->info->user_data['user_id']}';")) != 1) {
					$mmhclass->templ->error("You cannot rename the requested album because you do not own it.", true);
				} else {
					$mmhclass->db->query("UPDATE `mmh_gallery_albums` SET `album_title` = '{$mmhclass->input->post_vars['album_title']}' WHERE `album_id` = '{$album_id}';");
				
					$mmhclass->templ->message("Album has been successfully renamed. <br /><br /> <a href=\"index.php?rurl={$mmhclass->input->post_vars['return']}\">Return To Previous Page</a> <br /> <a href=\"index.php\">Site Index</a>", true);
				}
			}
			break;
		case "albums-d":
			if ($mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} else {
				$album_id = round($mmhclass->input->get_vars['album']);
				
				if ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_gallery_albums` WHERE `album_id` = '{$album_id}' AND `gallery_id` = '{$mmhclass->info->user_data['user_id']}';")) != 1) {
					$mmhclass->templ->error("You cannot delete the requested album because you do not own it.", true);
				} else {
					$mmhclass->templ->templ_vars[] = array(
						"ALBUM_TO_DELETE" => $album_id,
						"LIGHTBOX_ID"     => $mmhclass->input->get_vars['lb_div'],
						"RETURN_URL"      => $mmhclass->input->get_vars['return'],
					);
			
					exit($mmhclass->templ->parse_template("users", "delete_album_lightbox"));
				}
			}
			break;
		case "albums-d-d":
			$mmhclass->templ->page_title .= "Delete Album";
			
			if ($mmhclass->funcs->is_null($mmhclass->input->post_vars['album']) == true || $mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} else {
				$album_id = round($mmhclass->input->post_vars['album']);
				
				if ($mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_gallery_albums` WHERE `album_id` = '{$album_id}' AND `gallery_id` = '{$mmhclass->info->user_data['user_id']}';")) != 1) {
					$mmhclass->templ->error("You cannot delete the requested album because you do not own it.", true);
				} else {
					$mmhclass->db->query("UPDATE `mmh_file_storage` SET `album_id` = '0' WHERE `album_id` = '{$album_id}' AND `gallery_id`  = '{$mmhclass->info->user_data['user_id']}';");
					$mmhclass->db->query("DELETE FROM `mmh_gallery_albums` WHERE `album_id` = '{$album_id}' AND `gallery_id`  = '{$mmhclass->info->user_data['user_id']}';");

					$mmhclass->templ->message("Album has been successfully deleted. <br /><br /> <a href=\"index.php?rurl={$mmhclass->input->post_vars['return']}\">Return To Previous Page</a> <br /> <a href=\"index.php\">Site Index</a>", true);
				}
			}
			break;
		case "settings":
			$mmhclass->templ->page_title .= "User Settings";
			
			if ($mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} else {
				$mmhclass->templ->templ_vars[] = array(
					"USER_ID"             => $mmhclass->info->user_data['user_id'],
					"USERNAME"            => $mmhclass->info->user_data['username'],
					"IP_ADDRESS"          => $mmhclass->info->user_data['ip_address'],
					"EMAIL_ADDRESS"       => $mmhclass->info->user_data['email_address'],
					"PRIVATE_GALLERY_YES" => (($mmhclass->info->user_data['private_gallery'] == 1) ? "checked=\"checked\"" : NULL),
					"PRIVATE_GALLERY_NO"  => (($mmhclass->info->user_data['private_gallery'] == 0) ? "checked=\"checked\"" : NULL),
					"TIME_JOINED"         => date($mmhclass->info->config['date_format'], $mmhclass->info->user_data['time_joined']),
					"USER_GROUP"          => ((preg_match("/admin/i", $mmhclass->info->user_data['user_group']) == true) ? "Administrator" : "Normal User"),
				);
			
				$mmhclass->templ->output("users", "user_settings_page");
			}
			break;
		case "settings-s":
			$mmhclass->templ->page_title .= "User Settings";

			if ($mmhclass->info->is_user == false) {
				$mmhclass->templ->error("Sorry but you do not have permission to use this page.", true);
			} elseif ($mmhclass->funcs->is_null($mmhclass->input->post_vars['email_address']) == true) {
				$mmhclass->templ->error("Please ensure that all required fields of the form on the previous page had been filled in correctly.", true);
			} elseif ($mmhclass->funcs->valid_email($mmhclass->input->post_vars['email_address']) == false) {
				$mmhclass->templ->error("The email address entered appears to be invalid.", true);
			} elseif ($mmhclass->funcs->is_null($mmhclass->input->post_vars['password']) == false && strlen($mmhclass->input->post_vars['password']) < 6 || strlen($mmhclass->input->post_vars['password']) > 30) {
				$mmhclass->templ->error("Please ensure you have entered a valid password.", true);
			} elseif ($mmhclass->input->post_vars['email_address'] != $mmhclass->info->user_data['email_address'] && $mmhclass->db->total_rows($mmhclass->db->query("SELECT * FROM `mmh_user_info` WHERE `email_address` = '{$mmhclass->input->post_vars['email_address']}';")) == 1) {
				$mmhclass->templ->error("Sorry but the entered email address is already in use.", true);
			} else {
				$mmhclass->db->query("UPDATE `mmh_user_info` SET `email_address` = '{$mmhclass->input->post_vars['email_address']}', `private_gallery` = '{$mmhclass->input->post_vars['private_gallery']}' WHERE `user_id` = '{$mmhclass->info->user_data['user_id']}';");

				if ($mmhclass->funcs->is_null($mmhclass->input->post_vars['password']) == false) {
					$user_password = md5($mmhclass->input->post_vars['password']);
					$mmhclass->db->query("UPDATE `mmh_user_info` SET `password` = '{$user_password}' WHERE `user_id` = '{$mmhclass->info->user_data['user_id']}';");
				}

				$mmhclass->templ->message("Settings have been successfully updated. <br /><br /> <a href=\"users.php?act=settings\">Edit Settings Again</a> <br /> <a href=\"index.php\">Site Index</a>", true);
			}
			break;
		default: 
			$mmhclass->templ->error("You have reached this page in error, please use your back button to return to {$mmhclass->info->config['site_name']}.");
	}

?>
