<?php
	// ======================================== \
	// Package: Mihalism Multi Host
	// Version: 4.0.0
	// Copyright (c) 2007, 2008 Mihalism, Inc.
	// License: http://www.gnu.org/licenses/gpl.txt GNU Public License
	// ======================================== /

	require_once "./source/includes/data.php";

	$mmhclass->templ->page_title = "{$mmhclass->info->config['site_name']} &raquo; File Viewer";

	if ($mmhclass->funcs->is_null($mmhclass->input->get_vars['file']) == true) {
		$mmhclass->templ->error("Please select a file to continue.", true);
	} elseif (is_file($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].basename($mmhclass->input->get_vars['file'])) == false) {
		$mmhclass->templ->error("The requested file <b>{$mmhclass->input->get_vars['file']}</b> does not exist.", true);
	} elseif (in_array($mmhclass->funcs->file_extension($mmhclass->input->get_vars['file']), array("jpg", "jpeg", "ico", "bmp", "gif", "png")) == false) {
		$mmhclass->templ->error("The requested file is not a valid image format. Click <a href=\"download.php?file={$mmhclass->input->get_vars['file']}\">here</a> to download the requested file.", true);
	} else {
		$filename    = basename($mmhclass->input->get_vars['file']);
		$rating_info = $mmhclass->db->fetch_array($mmhclass->db->query("SELECT * FROM `mmh_file_ratings` WHERE `filename` = '{$filename}';"));
		$file_info   = getimagesize($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].$filename);
	
		if ($mmhclass->input->get_vars['act'] == "rate_it" && $mmhclass->funcs->is_null($mmhclass->input->post_vars['rating_id']) == false) {
			$mmhclass->templ->templ_globals['new_file_rating'] = true;
			if (in_array($mmhclass->input->server_vars['remote_addr'], preg_split("/\|/", $rating_info['voted_by'])) == true) {
				$new_rating_html = $mmhclass->templ->error("Your IP address has already placed a rating on this image.", false);
			} else {
				if ($mmhclass->funcs->is_null($rating_info['rating_id']) == true) {
					$mmhclass->db->query("INSERT INTO `mmh_file_ratings` (`filename`, `total_rating`, `total_votes`, `voted_by`) VALUES ('{$filename}', '0', '0', '');");
				}
				$mmhclass->db->query("UPDATE `mmh_file_ratings` SET `total_rating` = `total_rating` + {$mmhclass->input->post_vars['rating_id']}, `total_votes` = `total_votes` + 1, `voted_by` = '{$rating_info['voted_by']}|{$mmhclass->input->server_vars['remote_addr']}' WHERE `filename` = '{$filename}';");
				$new_rating_html = $mmhclass->templ->message("Your rating has been successfully submitted. Below is the updated file rating. <br /><br /> <img src=\"index.php?module=rating&file={$filename}\" alt=\"File Rating\" />", false);
			}
		}
	
		$mmhclass->templ->templ_globals['file_info'] = $file_info;
		$mmhclass->templ->templ_vars[] = array(
			"UPLOAD_PATH"        => $mmhclass->info->config['upload_path'],
			"FILENAME"           => $filename,
			"IMAGE_WIDTH"        => $file_info['0'],
			"IMAGE_HEIGHT"       => $file_info['1'],
			"FILE_EXTENSION"     => $mmhclass->funcs->file_extension($filename),
			"MIME_TYPE"          => $file_info['mime'],
			"DATE_UPLOADED"      => date($mmhclass->info->config['date_format'], filemtime($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].$filename)),
			"TOTAL_FILESIZE"     => $mmhclass->funcs->format_filesize(filesize($mmhclass->info->root_path.$mmhclass->info->config['upload_path'].$filename)),
			"TOTAL_RATINGS"      => $mmhclass->funcs->format_number($rating_info['total_votes']),
			"FILE_LINKS"         => $mmhclass->templ->file_results($filename),
			"NEW_RATING_HTML"    => $new_rating_html,
		);
	
		$mmhclass->templ->output("viewer");
	}

?>
